/* archiveReader.c generated by valac 0.34.6, the Vala compiler
 * generated from archiveReader.vala, do not modify */

/*///////////////////////////////////////////////////////////////////////*/
/* Copyright (c) 2011-2017 by Simon Schneegans*/
/**/
/* This program is free software: you can redistribute it and/or modify*/
/* it under the terms of the GNU General Public License as published by*/
/* the Free Software Foundation, either version 3 of the License, or (at*/
/* your option) any later version.*/
/**/
/* This program is distributed in the hope that it will be useful, but*/
/* WITHOUT ANY WARRANTY; without even the implied warranty of*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/* General Public License for more details.*/
/**/
/* You should have received a copy of the GNU General Public License*/
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*///////////////////////////////////////////////////////////////////////*/

#include <glib.h>
#include <glib-object.h>
#include <archive.h>
#include <stdlib.h>
#include <string.h>
#include <archive_entry.h>
#include <sys/types.h>


#define GNOME_PIE_TYPE_ARCHIVE_READER (gnome_pie_archive_reader_get_type ())
#define GNOME_PIE_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOME_PIE_TYPE_ARCHIVE_READER, GnomePieArchiveReader))
#define GNOME_PIE_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOME_PIE_TYPE_ARCHIVE_READER, GnomePieArchiveReaderClass))
#define GNOME_PIE_IS_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOME_PIE_TYPE_ARCHIVE_READER))
#define GNOME_PIE_IS_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOME_PIE_TYPE_ARCHIVE_READER))
#define GNOME_PIE_ARCHIVE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOME_PIE_TYPE_ARCHIVE_READER, GnomePieArchiveReaderClass))

typedef struct _GnomePieArchiveReader GnomePieArchiveReader;
typedef struct _GnomePieArchiveReaderClass GnomePieArchiveReaderClass;
typedef struct _GnomePieArchiveReaderPrivate GnomePieArchiveReaderPrivate;
#define _archive_read_finish0(var) ((var == NULL) ? NULL : (var = (archive_read_finish (var), NULL)))
#define _archive_write_finish0(var) ((var == NULL) ? NULL : (var = (archive_write_finish (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GnomePieArchiveReader {
	GObject parent_instance;
	GnomePieArchiveReaderPrivate * priv;
};

struct _GnomePieArchiveReaderClass {
	GObjectClass parent_class;
};

struct _GnomePieArchiveReaderPrivate {
	struct archive* archive;
	struct archive* writer;
};


static gpointer gnome_pie_archive_reader_parent_class = NULL;

GType gnome_pie_archive_reader_get_type (void) G_GNUC_CONST;
#define GNOME_PIE_ARCHIVE_READER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOME_PIE_TYPE_ARCHIVE_READER, GnomePieArchiveReaderPrivate))
enum  {
	GNOME_PIE_ARCHIVE_READER_DUMMY_PROPERTY
};
GnomePieArchiveReader* gnome_pie_archive_reader_new (void);
GnomePieArchiveReader* gnome_pie_archive_reader_construct (GType object_type);
gboolean gnome_pie_archive_reader_open (GnomePieArchiveReader* self, const gchar* path);
gboolean gnome_pie_archive_reader_extract_to (GnomePieArchiveReader* self, const gchar* directory);
void gnome_pie_archive_reader_close (GnomePieArchiveReader* self);
static void gnome_pie_archive_reader_finalize (GObject* obj);


GnomePieArchiveReader* gnome_pie_archive_reader_construct (GType object_type) {
	GnomePieArchiveReader * self = NULL;
	struct archive* _tmp0_ = NULL;
	struct archive* _tmp1_ = NULL;
	struct archive* _tmp2_ = NULL;
	struct archive* _tmp3_ = NULL;
	struct archive* _tmp4_ = NULL;
	struct archive* _tmp5_ = NULL;
	self = (GnomePieArchiveReader*) g_object_new (object_type, NULL);
	_tmp0_ = archive_read_new ();
	_archive_read_finish0 (self->priv->archive);
	self->priv->archive = _tmp0_;
	_tmp1_ = self->priv->archive;
	archive_read_support_format_all (_tmp1_);
	_tmp2_ = self->priv->archive;
	archive_read_support_filter_all (_tmp2_);
	_tmp3_ = archive_write_disk_new ();
	_archive_write_finish0 (self->priv->writer);
	self->priv->writer = _tmp3_;
	_tmp4_ = self->priv->writer;
	archive_write_disk_set_options (_tmp4_, ((ARCHIVE_EXTRACT_TIME | ARCHIVE_EXTRACT_PERM) | ARCHIVE_EXTRACT_ACL) | ARCHIVE_EXTRACT_FFLAGS);
	_tmp5_ = self->priv->writer;
	archive_write_disk_set_standard_lookup (_tmp5_);
	return self;
}


GnomePieArchiveReader* gnome_pie_archive_reader_new (void) {
	return gnome_pie_archive_reader_construct (GNOME_PIE_TYPE_ARCHIVE_READER);
}


gboolean gnome_pie_archive_reader_open (GnomePieArchiveReader* self, const gchar* path) {
	gboolean result = FALSE;
	struct archive* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	int _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = self->priv->archive;
	_tmp1_ = path;
	_tmp2_ = archive_read_open_filename (_tmp0_, _tmp1_, (gsize) 10240);
	result = _tmp2_ == ARCHIVE_OK;
	return result;
}


gboolean gnome_pie_archive_reader_extract_to (GnomePieArchiveReader* self, const gchar* directory) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (directory != NULL, FALSE);
	while (TRUE) {
		struct archive_entry* entry = NULL;
		int r = 0;
		struct archive* _tmp0_ = NULL;
		struct archive_entry* _tmp1_ = NULL;
		int _tmp2_ = 0;
		int _tmp3_ = 0;
		int _tmp4_ = 0;
		struct archive_entry* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		struct archive_entry* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		struct archive* _tmp15_ = NULL;
		struct archive_entry* _tmp16_ = NULL;
		int _tmp17_ = 0;
		int _tmp18_ = 0;
		struct archive_entry* _tmp21_ = NULL;
		gint64 _tmp22_ = 0LL;
		struct archive* _tmp36_ = NULL;
		int _tmp37_ = 0;
		int _tmp38_ = 0;
		_tmp0_ = self->priv->archive;
		_tmp2_ = archive_read_next_header (_tmp0_, &_tmp1_);
		entry = _tmp1_;
		r = _tmp2_;
		_tmp3_ = r;
		if (_tmp3_ == ARCHIVE_EOF) {
			break;
		}
		_tmp4_ = r;
		if (_tmp4_ != ARCHIVE_OK) {
			struct archive* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			_tmp5_ = self->priv->archive;
			_tmp6_ = archive_error_string (_tmp5_);
			g_warning ("archiveReader.vala:71: %s", _tmp6_);
			result = FALSE;
			return result;
		}
		_tmp7_ = entry;
		_tmp8_ = directory;
		_tmp9_ = g_strconcat (_tmp8_, "/", NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = entry;
		_tmp12_ = archive_entry_pathname (_tmp11_);
		_tmp13_ = g_strconcat (_tmp10_, _tmp12_, NULL);
		_tmp14_ = _tmp13_;
		archive_entry_set_pathname (_tmp7_, _tmp14_);
		_g_free0 (_tmp14_);
		_g_free0 (_tmp10_);
		_tmp15_ = self->priv->writer;
		_tmp16_ = entry;
		_tmp17_ = archive_write_header (_tmp15_, _tmp16_);
		r = _tmp17_;
		_tmp18_ = r;
		if (_tmp18_ != ARCHIVE_OK) {
			struct archive* _tmp19_ = NULL;
			const gchar* _tmp20_ = NULL;
			_tmp19_ = self->priv->writer;
			_tmp20_ = archive_error_string (_tmp19_);
			g_warning ("archiveReader.vala:80: %s", _tmp20_);
			result = FALSE;
			return result;
		}
		_tmp21_ = entry;
		_tmp22_ = archive_entry_size (_tmp21_);
		if (_tmp22_ > ((gint64) 0)) {
			while (TRUE) {
				gsize offset = 0UL;
				gsize size = 0UL;
				void* buff = NULL;
				struct archive* _tmp23_ = NULL;
				void* _tmp24_ = NULL;
				gsize _tmp25_ = 0UL;
				off_t _tmp26_ = {0};
				int _tmp27_ = 0;
				int _tmp28_ = 0;
				int _tmp29_ = 0;
				struct archive* _tmp32_ = NULL;
				void* _tmp33_ = NULL;
				gsize _tmp34_ = 0UL;
				gsize _tmp35_ = 0UL;
				_tmp23_ = self->priv->archive;
				_tmp27_ = archive_read_data_block (_tmp23_, &_tmp24_, &_tmp25_, &_tmp26_);
				buff = _tmp24_;
				size = _tmp25_;
				offset = (gsize) _tmp26_;
				r = _tmp27_;
				_tmp28_ = r;
				if (_tmp28_ == ARCHIVE_EOF) {
					break;
				}
				_tmp29_ = r;
				if (_tmp29_ != ARCHIVE_OK) {
					struct archive* _tmp30_ = NULL;
					const gchar* _tmp31_ = NULL;
					_tmp30_ = self->priv->archive;
					_tmp31_ = archive_error_string (_tmp30_);
					g_warning ("archiveReader.vala:95: %s", _tmp31_);
					result = FALSE;
					return result;
				}
				_tmp32_ = self->priv->writer;
				_tmp33_ = buff;
				_tmp34_ = size;
				_tmp35_ = offset;
				archive_write_data_block (_tmp32_, _tmp33_, _tmp34_, (off_t) _tmp35_);
			}
		}
		_tmp36_ = self->priv->writer;
		_tmp37_ = archive_write_finish_entry (_tmp36_);
		r = _tmp37_;
		_tmp38_ = r;
		if (_tmp38_ != ARCHIVE_OK) {
			struct archive* _tmp39_ = NULL;
			const gchar* _tmp40_ = NULL;
			_tmp39_ = self->priv->writer;
			_tmp40_ = archive_error_string (_tmp39_);
			g_warning ("archiveReader.vala:106: %s", _tmp40_);
			result = FALSE;
			return result;
		}
	}
	result = TRUE;
	return result;
}


void gnome_pie_archive_reader_close (GnomePieArchiveReader* self) {
	struct archive* _tmp0_ = NULL;
	struct archive* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->archive;
	archive_read_close (_tmp0_);
	_tmp1_ = self->priv->writer;
	archive_write_close (_tmp1_);
}


static void gnome_pie_archive_reader_class_init (GnomePieArchiveReaderClass * klass) {
	gnome_pie_archive_reader_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GnomePieArchiveReaderPrivate));
	G_OBJECT_CLASS (klass)->finalize = gnome_pie_archive_reader_finalize;
}


static void gnome_pie_archive_reader_instance_init (GnomePieArchiveReader * self) {
	self->priv = GNOME_PIE_ARCHIVE_READER_GET_PRIVATE (self);
}


static void gnome_pie_archive_reader_finalize (GObject* obj) {
	GnomePieArchiveReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNOME_PIE_TYPE_ARCHIVE_READER, GnomePieArchiveReader);
	_archive_read_finish0 (self->priv->archive);
	_archive_write_finish0 (self->priv->writer);
	G_OBJECT_CLASS (gnome_pie_archive_reader_parent_class)->finalize (obj);
}


GType gnome_pie_archive_reader_get_type (void) {
	static volatile gsize gnome_pie_archive_reader_type_id__volatile = 0;
	if (g_once_init_enter (&gnome_pie_archive_reader_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomePieArchiveReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnome_pie_archive_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomePieArchiveReader), 0, (GInstanceInitFunc) gnome_pie_archive_reader_instance_init, NULL };
		GType gnome_pie_archive_reader_type_id;
		gnome_pie_archive_reader_type_id = g_type_register_static (G_TYPE_OBJECT, "GnomePieArchiveReader", &g_define_type_info, 0);
		g_once_init_leave (&gnome_pie_archive_reader_type_id__volatile, gnome_pie_archive_reader_type_id);
	}
	return gnome_pie_archive_reader_type_id__volatile;
}



