/* archiveWriter.c generated by valac 0.34.6, the Vala compiler
 * generated from archiveWriter.vala, do not modify */

/*///////////////////////////////////////////////////////////////////////*/
/* Copyright (c) 2011-2017 by Simon Schneegans*/
/**/
/* This program is free software: you can redistribute it and/or modify*/
/* it under the terms of the GNU General Public License as published by*/
/* the Free Software Foundation, either version 3 of the License, or (at*/
/* your option) any later version.*/
/**/
/* This program is distributed in the hope that it will be useful, but*/
/* WITHOUT ANY WARRANTY; without even the implied warranty of*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/* General Public License for more details.*/
/**/
/* You should have received a copy of the GNU General Public License*/
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*///////////////////////////////////////////////////////////////////////*/

#include <glib.h>
#include <glib-object.h>
#include <archive.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <archive_entry.h>
#include <sys/stat.h>
#include <gio/gio.h>


#define GNOME_PIE_TYPE_ARCHIVE_WRITER (gnome_pie_archive_writer_get_type ())
#define GNOME_PIE_ARCHIVE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOME_PIE_TYPE_ARCHIVE_WRITER, GnomePieArchiveWriter))
#define GNOME_PIE_ARCHIVE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOME_PIE_TYPE_ARCHIVE_WRITER, GnomePieArchiveWriterClass))
#define GNOME_PIE_IS_ARCHIVE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOME_PIE_TYPE_ARCHIVE_WRITER))
#define GNOME_PIE_IS_ARCHIVE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOME_PIE_TYPE_ARCHIVE_WRITER))
#define GNOME_PIE_ARCHIVE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOME_PIE_TYPE_ARCHIVE_WRITER, GnomePieArchiveWriterClass))

typedef struct _GnomePieArchiveWriter GnomePieArchiveWriter;
typedef struct _GnomePieArchiveWriterClass GnomePieArchiveWriterClass;
typedef struct _GnomePieArchiveWriterPrivate GnomePieArchiveWriterPrivate;
#define _archive_write_finish0(var) ((var == NULL) ? NULL : (var = (archive_write_finish (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _archive_entry_free0(var) ((var == NULL) ? NULL : (var = (archive_entry_free (var), NULL)))

struct _GnomePieArchiveWriter {
	GObject parent_instance;
	GnomePieArchiveWriterPrivate * priv;
};

struct _GnomePieArchiveWriterClass {
	GObjectClass parent_class;
};

struct _GnomePieArchiveWriterPrivate {
	struct archive* archive;
};


static gpointer gnome_pie_archive_writer_parent_class = NULL;

GType gnome_pie_archive_writer_get_type (void) G_GNUC_CONST;
#define GNOME_PIE_ARCHIVE_WRITER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOME_PIE_TYPE_ARCHIVE_WRITER, GnomePieArchiveWriterPrivate))
enum  {
	GNOME_PIE_ARCHIVE_WRITER_DUMMY_PROPERTY
};
GnomePieArchiveWriter* gnome_pie_archive_writer_new (void);
GnomePieArchiveWriter* gnome_pie_archive_writer_construct (GType object_type);
gboolean gnome_pie_archive_writer_open (GnomePieArchiveWriter* self, const gchar* path);
gboolean gnome_pie_archive_writer_add (GnomePieArchiveWriter* self, const gchar* directory);
static gboolean gnome_pie_archive_writer_add_directory (GnomePieArchiveWriter* self, const gchar* directory, const gchar* relative_to);
void gnome_pie_archive_writer_close (GnomePieArchiveWriter* self);
gboolean gnome_pie_archive_writer_add_file (GnomePieArchiveWriter* self, const gchar* path, const gchar* relative_to);
static void gnome_pie_archive_writer_finalize (GObject* obj);


GnomePieArchiveWriter* gnome_pie_archive_writer_construct (GType object_type) {
	GnomePieArchiveWriter * self = NULL;
	struct archive* _tmp0_ = NULL;
	struct archive* _tmp1_ = NULL;
	struct archive* _tmp2_ = NULL;
	self = (GnomePieArchiveWriter*) g_object_new (object_type, NULL);
	_tmp0_ = archive_write_new ();
	_archive_write_finish0 (self->priv->archive);
	self->priv->archive = _tmp0_;
	_tmp1_ = self->priv->archive;
	archive_write_add_filter_gzip (_tmp1_);
	_tmp2_ = self->priv->archive;
	archive_write_set_format_pax_restricted (_tmp2_);
	return self;
}


GnomePieArchiveWriter* gnome_pie_archive_writer_new (void) {
	return gnome_pie_archive_writer_construct (GNOME_PIE_TYPE_ARCHIVE_WRITER);
}


gboolean gnome_pie_archive_writer_open (GnomePieArchiveWriter* self, const gchar* path) {
	gboolean result = FALSE;
	struct archive* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	int _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = self->priv->archive;
	_tmp1_ = path;
	_tmp2_ = archive_write_open_filename (_tmp0_, _tmp1_);
	result = _tmp2_ == ARCHIVE_OK;
	return result;
}


gboolean gnome_pie_archive_writer_add (GnomePieArchiveWriter* self, const gchar* directory) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (directory != NULL, FALSE);
	_tmp0_ = directory;
	_tmp1_ = directory;
	_tmp2_ = gnome_pie_archive_writer_add_directory (self, _tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


void gnome_pie_archive_writer_close (GnomePieArchiveWriter* self) {
	struct archive* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->archive;
	archive_write_close (_tmp0_);
}


static gboolean gnome_pie_archive_writer_add_directory (GnomePieArchiveWriter* self, const gchar* directory, const gchar* relative_to) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (directory != NULL, FALSE);
	g_return_val_if_fail (relative_to != NULL, FALSE);
	{
		GDir* d = NULL;
		const gchar* _tmp0_ = NULL;
		GDir* _tmp1_ = NULL;
		gchar* name = NULL;
		_tmp0_ = directory;
		_tmp1_ = g_dir_open (_tmp0_, (guint) 0, &_inner_error_);
		d = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch26_g_error;
		}
		while (TRUE) {
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
			const gchar* _tmp4_ = NULL;
			gchar* path = NULL;
			const gchar* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
			_tmp2_ = g_dir_read_name (d);
			_tmp3_ = g_strdup (_tmp2_);
			_g_free0 (name);
			name = _tmp3_;
			_tmp4_ = name;
			if (!(_tmp4_ != NULL)) {
				break;
			}
			_tmp5_ = directory;
			_tmp6_ = name;
			_tmp7_ = g_build_filename (_tmp5_, _tmp6_, NULL);
			path = _tmp7_;
			_tmp8_ = path;
			_tmp9_ = g_file_test (_tmp8_, G_FILE_TEST_IS_DIR);
			if (_tmp9_) {
				const gchar* _tmp10_ = NULL;
				const gchar* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				_tmp10_ = path;
				_tmp11_ = relative_to;
				_tmp12_ = gnome_pie_archive_writer_add_directory (self, _tmp10_, _tmp11_);
				if (!_tmp12_) {
					result = FALSE;
					_g_free0 (path);
					_g_free0 (name);
					_g_dir_close0 (d);
					return result;
				}
			} else {
				const gchar* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				_tmp13_ = path;
				_tmp14_ = g_file_test (_tmp13_, G_FILE_TEST_IS_REGULAR);
				if (_tmp14_) {
					const gchar* _tmp15_ = NULL;
					const gchar* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
					_tmp15_ = path;
					_tmp16_ = relative_to;
					_tmp17_ = gnome_pie_archive_writer_add_file (self, _tmp15_, _tmp16_);
					if (!_tmp17_) {
						result = FALSE;
						_g_free0 (path);
						_g_free0 (name);
						_g_dir_close0 (d);
						return result;
					}
				} else {
					const gchar* _tmp18_ = NULL;
					gchar* _tmp19_ = NULL;
					gchar* _tmp20_ = NULL;
					_tmp18_ = name;
					_tmp19_ = g_strconcat ("Packaging theme: Ignoring irregular file ", _tmp18_, NULL);
					_tmp20_ = _tmp19_;
					g_warning ("archiveWriter.vala:87: %s", _tmp20_);
					_g_free0 (_tmp20_);
				}
			}
			_g_free0 (path);
		}
		_g_free0 (name);
		_g_dir_close0 (d);
	}
	goto __finally26;
	__catch26_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_ = NULL;
		const gchar* _tmp22_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp21_ = e;
		_tmp22_ = _tmp21_->message;
		g_warning ("archiveWriter.vala:91: %s", _tmp22_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally26:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp23_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp23_;
	}
	result = TRUE;
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch27_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch27_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally27;
	__catch27_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally27:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gboolean gnome_pie_archive_writer_add_file (GnomePieArchiveWriter* self, const gchar* path, const gchar* relative_to) {
	gboolean result = FALSE;
	struct archive_entry* entry = NULL;
	struct archive_entry* _tmp0_ = NULL;
	struct archive_entry* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	struct stat st = {0};
	const gchar* _tmp6_ = NULL;
	struct stat _tmp7_ = {0};
	struct archive_entry* _tmp8_ = NULL;
	struct stat _tmp9_ = {0};
	struct archive_entry* _tmp10_ = NULL;
	struct stat _tmp11_ = {0};
	gsize _tmp12_ = 0UL;
	struct archive* _tmp13_ = NULL;
	struct archive_entry* _tmp14_ = NULL;
	int _tmp15_ = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (relative_to != NULL, FALSE);
	_tmp0_ = archive_entry_new ();
	entry = _tmp0_;
	_tmp1_ = entry;
	_tmp2_ = path;
	_tmp3_ = relative_to;
	_tmp4_ = string_replace (_tmp2_, _tmp3_, "");
	_tmp5_ = _tmp4_;
	archive_entry_set_pathname (_tmp1_, _tmp5_);
	_g_free0 (_tmp5_);
	_tmp6_ = path;
	stat (_tmp6_, &_tmp7_);
	st = _tmp7_;
	_tmp8_ = entry;
	_tmp9_ = st;
	archive_entry_copy_stat (_tmp8_, &_tmp9_);
	_tmp10_ = entry;
	_tmp11_ = st;
	_tmp12_ = _tmp11_.st_size;
	archive_entry_set_size (_tmp10_, (gint64) _tmp12_);
	_tmp13_ = self->priv->archive;
	_tmp14_ = entry;
	_tmp15_ = archive_write_header (_tmp13_, _tmp14_);
	if (_tmp15_ == ARCHIVE_OK) {
		{
			GFileInputStream* reader = NULL;
			const gchar* _tmp16_ = NULL;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_ = NULL;
			GFileInputStream* _tmp19_ = NULL;
			GFileInputStream* _tmp20_ = NULL;
			guint8 buffer[4096] = {0};
			gssize len = 0L;
			GFileInputStream* _tmp21_ = NULL;
			gssize _tmp22_ = 0L;
			struct archive* _tmp29_ = NULL;
			_tmp16_ = path;
			_tmp17_ = g_file_new_for_path (_tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = g_file_read (_tmp18_, NULL, &_inner_error_);
			_tmp20_ = _tmp19_;
			_g_object_unref0 (_tmp18_);
			reader = _tmp20_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch28_g_error;
			}
			_tmp21_ = reader;
			_tmp22_ = g_input_stream_read ((GInputStream*) _tmp21_, buffer, (gsize) 4096, NULL, &_inner_error_);
			len = _tmp22_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (reader);
				goto __catch28_g_error;
			}
			while (TRUE) {
				gssize _tmp23_ = 0L;
				struct archive* _tmp24_ = NULL;
				gssize _tmp25_ = 0L;
				gssize _tmp26_ = 0L;
				GFileInputStream* _tmp27_ = NULL;
				gssize _tmp28_ = 0L;
				_tmp23_ = len;
				if (!(_tmp23_ > ((gssize) 0))) {
					break;
				}
				_tmp24_ = self->priv->archive;
				_tmp25_ = len;
				archive_write_data (_tmp24_, buffer, (gsize) _tmp25_);
				_tmp27_ = reader;
				_tmp28_ = g_input_stream_read ((GInputStream*) _tmp27_, buffer, (gsize) 4096, NULL, &_inner_error_);
				_tmp26_ = _tmp28_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (reader);
					goto __catch28_g_error;
				}
				len = _tmp26_;
			}
			_tmp29_ = self->priv->archive;
			archive_write_finish_entry (_tmp29_);
			_g_object_unref0 (reader);
		}
		goto __finally28;
		__catch28_g_error:
		{
			GError* e = NULL;
			GError* _tmp30_ = NULL;
			const gchar* _tmp31_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp30_ = e;
			_tmp31_ = _tmp30_->message;
			g_warning ("archiveWriter.vala:126: %s", _tmp31_);
			result = FALSE;
			_g_error_free0 (e);
			_archive_entry_free0 (entry);
			return result;
		}
		__finally28:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gboolean _tmp32_ = FALSE;
			_archive_entry_free0 (entry);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp32_;
		}
	} else {
		const gchar* _tmp33_ = NULL;
		gchar* _tmp34_ = NULL;
		gchar* _tmp35_ = NULL;
		gchar* _tmp36_ = NULL;
		gchar* _tmp37_ = NULL;
		_tmp33_ = path;
		_tmp34_ = g_strconcat ("Failed to include file ", _tmp33_, NULL);
		_tmp35_ = _tmp34_;
		_tmp36_ = g_strconcat (_tmp35_, " into archive", NULL);
		_tmp37_ = _tmp36_;
		g_warning ("archiveWriter.vala:131: %s", _tmp37_);
		_g_free0 (_tmp37_);
		_g_free0 (_tmp35_);
		result = FALSE;
		_archive_entry_free0 (entry);
		return result;
	}
	result = TRUE;
	_archive_entry_free0 (entry);
	return result;
}


static void gnome_pie_archive_writer_class_init (GnomePieArchiveWriterClass * klass) {
	gnome_pie_archive_writer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GnomePieArchiveWriterPrivate));
	G_OBJECT_CLASS (klass)->finalize = gnome_pie_archive_writer_finalize;
}


static void gnome_pie_archive_writer_instance_init (GnomePieArchiveWriter * self) {
	self->priv = GNOME_PIE_ARCHIVE_WRITER_GET_PRIVATE (self);
}


static void gnome_pie_archive_writer_finalize (GObject* obj) {
	GnomePieArchiveWriter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNOME_PIE_TYPE_ARCHIVE_WRITER, GnomePieArchiveWriter);
	_archive_write_finish0 (self->priv->archive);
	G_OBJECT_CLASS (gnome_pie_archive_writer_parent_class)->finalize (obj);
}


GType gnome_pie_archive_writer_get_type (void) {
	static volatile gsize gnome_pie_archive_writer_type_id__volatile = 0;
	if (g_once_init_enter (&gnome_pie_archive_writer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomePieArchiveWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnome_pie_archive_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomePieArchiveWriter), 0, (GInstanceInitFunc) gnome_pie_archive_writer_instance_init, NULL };
		GType gnome_pie_archive_writer_type_id;
		gnome_pie_archive_writer_type_id = g_type_register_static (G_TYPE_OBJECT, "GnomePieArchiveWriter", &g_define_type_info, 0);
		g_once_init_leave (&gnome_pie_archive_writer_type_id__volatile, gnome_pie_archive_writer_type_id);
	}
	return gnome_pie_archive_writer_type_id__volatile;
}



